
#ifndef SYSDEF_H
#define SYSDEF_H

#pragma pack(1) // 结构体1字节对齐

#ifndef TRUE
#define TRUE 1
#endif

#ifndef FALSE
#define FALSE 0
#endif

#define ON 1
#define OFF 0

#define HIGH 1
#define LOW 0

typedef char CHAR;
typedef signed char int8, SBYTE;
typedef unsigned char uint8, BYTE, BOOL;

typedef short int16, SWORD;
typedef unsigned short uint16, WORD;

typedef int int32, SDWORD;
typedef unsigned int uint32, DWORD;

typedef float FLOAT, flt32;
typedef double DOUBLE, flt64;

typedef long long int64;
typedef unsigned long long uint64;

#define STATIC static

#define SYS_MEMSET memset
#define SYS_MEMCPY memcpy
#define SYS_MEMCMP memcmp
#define SYS_MEMMOVE memmove

#define SYS_STRCAT strcat
#define SYS_STRNCAT strncat
#define SYS_STRSTR strstr
#define SYS_STRCPY strcpy
#define SYS_STRCMP strcmp
#define SYS_STRLEN strlen

#define ntohs(x) (x)
#define ntohl(x) (x)
#define htons(x) (x)
#define htonl(x) (x)

#define BIT0 0x0001
#define BIT1 0x0002
#define BIT2 0x0004
#define BIT3 0x0008
#define BIT4 0x0010
#define BIT5 0x0020
#define BIT6 0x0040
#define BIT7 0x0080
#define BIT8 0x0100
#define BIT9 0x0200
#define BIT10 0x0400
#define BIT11 0x0800
#define BIT12 0x1000
#define BIT13 0x2000
#define BIT14 0x4000
#define BIT15 0x8000
#define BIT16 0x10000

#define SYS_RET_OK 0
#define SYS_RET_FAIL 1

#define SOFTWARE_VERSION "V3.0.01" // 第3代室内定位系统

#endif
