#include "./inc/includes.h"

typedef void (*pFunction)(void); // 定义一个函数指针

// 主函数入口
int main(void)
{
    main_bootloader_start();

    return 1;
}

// bootloader启动
// 启动地址0x08000000，区块大小64K(0x10000),
void main_bootloader_start()
{
    pFunction pJumpToApp;      // 函数指针
    uint32 dwResetAddress = 0; // 复位地址

    // 从下载区拷贝数据到程序区
    driverapp_cpuflash_copy_data_from_download_block();

    CLOSE_INT();
    main_deinit_nvic();
    RCC_DeInit();

    dwResetAddress = *(__IO uint32 *)(DRIVERAPP_APP_ADDRESS1 + 4); // 复位地址
    pJumpToApp = (pFunction)dwResetAddress;                        // 将复位地址转成函数指针

    // 跳转
    __set_MSP(*(__IO uint32 *)DRIVERAPP_APP_ADDRESS1); // 内核内联函数，将用户代码地址设为栈顶指针
    pJumpToApp();                                      // 执行函数，跳转

    while (1)
    {
        ;
    }

    return;
}

// 中断向量反向初始化
void main_deinit_nvic(void)
{
    uint32 index = 0;

    NVIC->ICER[0] = 0xFFFFFFFF;
    NVIC->ICER[1] = 0x0FFFFFFF;
    NVIC->ICPR[0] = 0xFFFFFFFF;
    NVIC->ICPR[1] = 0x0FFFFFFF;

    for (index = 0; index < 0X0F; index++)
    {
        NVIC->IP[index] = 0x00000000;
    }

    return;
}
